	.area text
;      semaphore -> 2,x
_bWait::
	      clra
	loop: maxm [2,x]
	      bcc loop
	
spin12.10::	
; /* ****************SPIN12.C********
;   Jonathan W. Valvano   April 21, 1998
;   Spinlock binary semaphore, 
;   without disabling interrupts */
; #include "spin12.h"
; void bWait(char *semaphore){
; asm("      clra\n"          // new value for semaphore
;     "loop: maxm [2,x]\n"    // test and set           
; 	"      bcc loop\n");            
; }                            
L1:
	rts
;      semaphore -> 2,x
_bSignal::
	pshd
	pshx
	tfr s,x
spin12.12::	
; void bSignal(char *semaphore){
;      (*semaphore)=1;  // compiler makes this atomic
	ldab #1
	ldy 2,x
	stab 0,y
spin12.13::	
; }
L2:
	tfr x,s
	pulx
	leas 2,sp
	rts
;      semaphore -> 2,x
_Wait::
	pshd
	pshx
	tfr s,x
spin12.29::	
; /* Example Usage:
; //-------------------------Start of OutString------------------------
; char mutex=1;    // 1 means free, 0 means in use
; // Output String (NULL termination)
; void OutString(char *pt){ char letter;
;    bWait(&mutex);
;    while (letter=*pt++)
;        OutChar(letter);
;    bSignal(&mutex);} 
; void main(void){
;    mutex=1;     // initially free
;    OutString("Hello World");}
;    */
; // reference Silberschatz Section 6.4.4
; void Wait(sema4Ptr semaphore){
;      bWait(&semaphore->s3);  // wait if other caller to Wait gets here first
	ldd 2,x
	addd #4
	jsr _bWait
spin12.30::	
;      bWait(&semaphore->s1);  // mutual exclusive access to value
	ldd 2,x
	addd #2
	jsr _bWait
spin12.31::	
;      (semaphore->value)--;  // basic function of Wait
	ldd [2,x]
	subd #1
	ldy 2,x
	std 0,y
spin12.32::	
;      if((semaphore->value)<0){
	ldd [2,x]
	bge L4
spin12.33::	
;          bSignal(&semaphore->s1); // end of mutual exclusive access to value
	ldd 2,x
	addd #2
	jsr _bSignal
spin12.34::	
;          bWait(&semaphore->s2);   // wait for value to go above 0
	ldd 2,x
	addd #3
	jsr _bWait
spin12.35::	
;          }
	bra L5
L4:
spin12.37::	
;      else
;          bSignal(&semaphore->s1); // end of mutual exclusive access to value
	ldd 2,x
	addd #2
	jsr _bSignal
L5:
spin12.38::	
;      bWait(&semaphore->s3);       // let other callers to Wait get in
	ldd 2,x
	addd #4
	jsr _bWait
spin12.39::	
; }                            
L3:
	tfr x,s
	pulx
	leas 2,sp
	rts
;      semaphore -> 2,x
_Signal::
	pshd
	pshx
	tfr s,x
spin12.41::	
; void Signal(sema4Ptr semaphore){
;      bWait(&semaphore->s1);  // mutual exclusive access to value
	ldd 2,x
	addd #2
	jsr _bWait
spin12.42::	
;      (semaphore->value)++;  // basic function of Signal
	ldd [2,x]
	addd #1
	ldy 2,x
	std 0,y
spin12.43::	
;      if((semaphore->value)<=0)
	ldd [2,x]
	bgt L7
spin12.44::	
;         bSignal(&semaphore->s2);   // allow S2 spinner to continue
	ldd 2,x
	addd #3
	jsr _bSignal
L7:
spin12.45::	
;      bSignal(&semaphore->s1); // end of mutual exclusive access to value
	ldd 2,x
	addd #2
	jsr _bSignal
spin12.46::	
; }
L6:
	tfr x,s
	pulx
	leas 2,sp
	rts
;        initial -> 6,x
;      semaphore -> 2,x
_Initialize::
	pshd
	pshx
	tfr s,x
spin12.48::	
; void Initialize(sema4Ptr semaphore, int initial){
;     semaphore->s1=1;   // first one to bWait(s1) continues
	ldab #1
	ldy 2,x
	stab 2,y
spin12.49::	
;     semaphore->s2=0;   // first one to bWait(s2) spins
	ldy 2,x
	clr 3,y
spin12.50::	
;     semaphore->s3=1;   // first one to bWait(s3) continues
	ldab #1
	ldy 2,x
	stab 4,y
spin12.51::	
;     semaphore->value=initial;}
	ldd 6,x
	ldy 2,x
	std 0,y
L9:
	tfr x,s
	pulx
	leas 2,sp
	rts
_InitFifo::
	pshx
	tfr s,x
	leas -2,sp
spin12.63::	
; // Example
; unsigned int *PutPt;    /* Pointer of where to put next */
; unsigned int *GetPt;    /* Pointer of where to get next
; /* FIFO is empty when Available is less than or equal to zero */
; /* FIFO is full  when RoomLeft is less than or equal to zero */
; sema4Type RoomLeft;  /* Semaphore counting empty spaces */
; sema4Type Available; /* Semaphore counting data in fifo */
; char Mutex;          // binary semaphore for mutual exclusion
; #define FifoSize 10
; unsigned int Fifo[FifoSize];     /* The statically allocated fifo data */
; void InitFifo(void) {
;    Initialize(&RoomLeft,FifoSize-1);    /* Maximum storage capability */
	movw #9,0,sp
	ldd #_RoomLeft
	jsr _Initialize
spin12.64::	
;    Initialize(&Available,0);            /* Initially empty */
	movw #0,0,sp
	ldd #_Available
	jsr _Initialize
spin12.65::	
;    Mutex=1;
	movb #1,_Mutex
spin12.66::	
;    PutPt=GetPt=&Fifo[0];
	movw #_Fifo,_GetPt
	movw #_Fifo,_PutPt
spin12.67::	
; }
L10:
	tfr x,s
	pulx
	rts
;           data -> 2,x
_Put::
	pshd
	pshx
	tfr s,x
	leas -4,sp
spin12.70::	
; 
; void Put(unsigned int data) { 
;    Wait(&RoomLeft);
	ldd #_RoomLeft
	jsr _Wait
spin12.71::	
;    bWait(&Mutex);
	ldd #_Mutex
	jsr _bWait
spin12.72::	
;    *(PutPt++)=data;  // Put data into fifo
	movw _PutPt,-2,x
	ldd -2,x
	addd #2
	std _PutPt
	ldd 2,x
	ldy -2,x
	std 0,y
spin12.73::	
;    if (PutPt==&Fifo[FifoSize]) PutPt = &Fifo[0];
	ldd #_Fifo+20
	std -4,x
	ldd _PutPt
	cpd -4,x
	bne L12
	movw #_Fifo,_PutPt
L12:
spin12.74::	
;    bSignal(&Mutex);
	ldd #_Mutex
	jsr _bSignal
spin12.75::	
;    Signal(&Available);
	ldd #_Available
	jsr _Signal
spin12.76::	
; }
L11:
	tfr x,s
	pulx
	leas 2,sp
	rts
;           data -> -2,x
_Get::
	pshx
	tfr s,x
	leas -6,sp
spin12.79::	
; 
; unsigned int Get(void) { unsigned int data;  
;    Wait(&Available);
	ldd #_Available
	jsr _Wait
spin12.80::	
;    bWait(&Mutex);
	ldd #_Mutex
	jsr _bWait
spin12.81::	
;    data=*(GetPt++);
	movw _GetPt,-4,x
	ldd -4,x
	addd #2
	std _GetPt
	ldd [-4,x]
	std -2,x
spin12.82::	
;    if (GetPt==&Fifo[FifoSize]) GetPt = &Fifo[0];
	ldd #_Fifo+20
	std -6,x
	ldd _GetPt
	cpd -6,x
	bne L16
	movw #_Fifo,_GetPt
L16:
spin12.83::	
;    bSignal(&Mutex);
	ldd #_Mutex
	jsr _bSignal
spin12.84::	
;    Signal(&RoomLeft);
	ldd #_RoomLeft
	jsr _Signal
spin12.85::	
;    return(data);}
	ldd -2,x
	tfr x,s
	pulx
	rts
L15:
;              n -> -2,x
_main::
	pshx
	tfr s,x
	leas -6,sp
spin12.87::	
; void main(void){ unsigned int n;
;    InitFifo();
	jsr _InitFifo
spin12.88::	
;    Put(5);
	ldd #5
	jsr _Put
spin12.89::	
;    Put(6);
	ldd #6
	jsr _Put
spin12.90::	
;    n=Get();
	jsr _Get
	std -4,x
	tfr d,y
	sty -2,x
spin12.91::	
;    n=Get();}
	jsr _Get
	std -6,x
	tfr d,y
	sty -2,x
L19:
	tfr x,s
	pulx
	rts
	.area bss
_Fifo::
	.blkb 20
_Mutex::
	.blkb 1
_Available::
	.blkb 6
_RoomLeft::
	.blkb 6
_GetPt::
	.blkb 2
_PutPt::
	.blkb 2
